(* * * * * * * * * * * * * * * * * * * * * * * *
 *       ⥪  ࠡ           *
 * * * * * * * * * * * * * * * * * * * * * * * *
 *           (c) 㫥订 .. 2000             *
 *             URL: pro3d.boom.ru              *
 *          e-mail: nord_ak@mail.ru            *
 * * * * * * * * * * * * * * * * * * * * * * * *)

unit MyMouse;

interface
{ TRUE = 㦥 ࠩ  }
function MLoaded : boolean;
{ -    }
function MButtons : word;
{   }
procedure MOn;
{ 몫  }
procedure MOff;
{    }
function MGetPos(var x, y : word) : word;
{ ⠭   }
procedure MSetPos(x, y : word);
{  ࠡ  }
procedure MSetWindow(x1, y1, x2, y2 : word);
{  ࠩ }
function MVersion : string;
{   }
function MType : string;
{ 뢠 . ࠡ稪 }
function MIRQ : byte;
{    }
procedure WaitMove;
{    (not s);  ﭨ  (s) }
procedure WaitButton(s:boolean);

implementation

function MLoaded : boolean;
  var
    x : word;
  begin
    asm
      mov ax, $0000
      int 33h
      mov x, ax
    end;
    if x <> 0 then MLoaded := true else MLoaded := false;
  end;

function MButtons : word;
  var
    x : word;
  begin
    asm
      mov ax, 0
      int 33h
      mov x, bx
    end;
    MButtons := x;
  end;

procedure MOn; assembler;
  asm
    mov ax, 1
    int 33h
  end;

procedure MOff; assembler;
  asm
    mov ax, 2
    int 33h
  end;

function MGetPos(var x, y: word) : word;
  var
    x1, y1, b1 : word;
  begin
    asm
      mov ax, 3
      int 33h
      mov x1, cx
      mov y1, dx
      mov b1, bx
    end;
    x := x1;
    y := y1;
    MGetPos := b1;
  end;

procedure MSetPos(x, y : word); assembler;
  asm
    mov ax, 4
    mov cx, x
    mov dx, y
    int 33h
  end;

procedure MSetWindow(x1, y1, x2, y2 : word); assembler;
  asm
    mov ax, 7
    mov cx, x1
    mov dx, x2
    int 33h
    mov ax, 8
    mov cx, y1
    mov dx, y2
    int 33h
  end;

function MVersion : string;
  var
    s, s1 : string[2];
    a, b : byte;
  begin
    asm
      mov ax, 0024h
      int 33h
      mov a, bh
      mov b, bl
    end;
    str(a, s);
    str(b, s1);
    MVersion := s+'.'+s1;
  end;

function MType : string;
  const
    a : array[1..5] of string[6] = ('BUS   ', 'SERIAL',
                                    'InPORT', 'PS/2  ', 'HP    ');
  var
    b : byte;
  begin
    asm
      mov ax, 0024h
      int 33h
      mov b, ch
    end;
    MType := a[b];
  end;

function MIRQ : byte;
  var
    b : byte;
  begin
    asm
      mov ax, 0024h
      int 33h
      mov b, cl
    end;
    MIRQ := b;
  end;

procedure WaitMove;
  var
    x1, y1, x, y : word;
  begin
    MGetPos(x1, y1);
    repeat
      MGetPos(x, y);
    until (x <> x1) or (y <> y1);
  end;

procedure WaitButton(s:boolean);
  var
    b1, x, y, b : word;
  begin
    b1 := MGetPos(x, y);
    repeat
      b := MGetPos(x, y);
    until (s and (b <> b1)) or (not s and (b <> 0));
  end;

BEGIN
END.
