(* * * * * * * * * * * * * * * * * * * * * * * *
 *      ⥪  ࠡ  䨪       *
 *          320x200x256 १             *
 * * * * * * * * * * * * * * * * * * * * * * * *
 *           (c) 㫥订 .. 2000             *
 *             URL: pro3d.boom.ru              *
 *          e-mail: nord_ak@mail.ru            *
 * * * * * * * * * * * * * * * * * * * * * * * *)

unit MyGraph;
{$M $8125,0,655350}

interface

type
  vid = array [0..319,0..199] of byte;
var
  pset : ^vid;                    {  }
  WnXS, WnXE, WnYS, WnYE : word;  {   }

{   }
procedure SetMode(mode:byte);
{     }
procedure retrace;
{    }
procedure SetDrawWindow(xs,ys,xe,ye:word);
{     }
function Point(x,y:word):byte;
{    }
procedure pal(color,r,g,b : byte);
{    }
procedure getpal(color:byte; var r,g,b:byte);
{       1  2 }
procedure palets(c1,c2,r1,g1,b1,r2,g2,b2:byte);
{     }
procedure DrawScr;
{     }
procedure ClrPset(c:byte);

implementation

var
  SaveExit : pointer;

procedure SetMode(mode:byte); assembler;
  asm
    mov ah, 0
    mov al, mode
    int 10h
  end;

procedure retrace; assembler;
  asm
    mov dx,3dah
  @vert2:
    in al,dx
    test al,8
    jnz @vert2
  @vert1:
    in al,dx
    test al,8
    jz @vert1
  end;

procedure SetDrawWindow(xs,ys,xe,ye:word);
  begin
    WnXS := xs; WnXE := xe; WnYS := ys; WnYE := ye;
  end;

procedure pal(color,r,g,b : byte);
  begin
    port[$3c8] := color;
    port[$3c9] := r;
    port[$3c9] := g;
    port[$3c9] := b;
  end;

function Point(x,y:word):byte;
  begin
    point := mem[$A000:y*320+x];
  end;

procedure getpal(color:byte; var r,g,b:byte);
  begin
    port[$3c7] := color;
    r := port[$3c9];
    g := port[$3c9];
    b := port[$3c9];
  end;

procedure palets(c1,c2,r1,g1,b1,r2,g2,b2:byte);
  var
    i,r,g,b : byte;
  begin
    for i := c1 to c2 do
      begin
        r := round(r1+(r2-r1)/(c2-c1)*(i-c1));
        g := round(g1+(g2-g1)/(c2-c1)*(i-c1));
        b := round(b1+(b2-b1)/(c2-c1)*(i-c1));
        pal(i,r,g,b);
      end;
  end;

procedure DrawScr;
  var
    x, y : word;
  begin
    for x := WnXS to WnXE do
    for y := WnYS to WnYE do mem[$A000:y*320+x] := pset^[x,y];
  end;

procedure ClrPset(c:byte);
  var
    x, y : word;
  begin
    for x := WnXS to WnXE do
    for y := WnYS to WnYE do Pset^[x,y] := c;
  end;

procedure ClosePset; far;
  begin
    Dispose(pset);
    ExitProc := SaveExit;
  end;

BEGIN
  New(pset);
  SetDrawWindow(0,0,319,199);
  SaveExit := ExitProc;
  ExitProc := @ClosePset;
END.
