unit General;

interface

type
      TCoordinates = record
        x, y, z : Longint;
      end;

      TMyPoly = record
        Indexes : array [0..3] of byte;
      end;

function ScalarMult(A, B : TCoordinates) : longint;
function min(p1, p2 : real) : real;
function max(p1, p2 : real) : real;

implementation

function ScalarMult(A, B : TCoordinates) : longint;
begin
  ScalarMult := A.X*B.X + A.Y*B.Y + A.Z*B.Z;
end;

function min(p1, p2 : real) : real;
begin
  if p1 < p2 then min := p1
             else min := p2;
end;

function max(p1, p2 : real) : real;
begin
  if p1 > p2 then max := p1
             else max := p2;
end;

End.