unit Surf;

interface
uses graph;
type
func =function(x,y:real):real;

function Aconv(x,y:integer;phi,psi:real):integer;
function Bconv(x,y:integer;phi,psi:real):integer;
procedure Surface(f:func;mx,my,mz:real);

type
arr=array[0..0]of integer;

var
phi,psi:real;
xcentr,ycentr:integer;
Xl,Xh,Yl,Yh:integer;
stepx:integer;
Osi:boolean;
implementation
var
horl:^arr;
horh:^arr;



function Aconv;
begin
Aconv:=round( x*cos(phi)-y*cos(psi));
end;

function Bconv;
begin
Bconv:=-round( y*sin(psi)+x*sin(phi) );
end;






procedure Surface;
var
  x,y,z:integer;
  a,b:integer;
begin
getmem(horl,getmaxx*sizeof(integer));
getmem(horh,getmaxx*sizeof(integer));
for a:=0 to getmaxx do horh^[a]:=0;
for a:=0 to getmaxx do horl^[a]:=getmaxy;
x:=xl;
y:=yl;
while x<=xh  do
     begin
          y:=yl;
          while y<= yh do
          begin
               b:=Bconv(x,y,phi,psi);
               a:=Aconv(x,y,phi,psi);
               z:=round(f(mx*x,my*y)*mz);
               b:=b-z;
               if (a>-xcentr)and(a<getmaxx)and(horl^[xcentr+a]>ycentr-b) then
               begin
                    putpixel(xcentr+a,ycentr+b,15);
                    horl^[xcentr+a]:=ycentr-b;
               end;
               if (a>-xcentr)and(a<getmaxx)and(horh^[xcentr+a]<ycentr-b) then
               begin
                    putpixel(xcentr+a,ycentr+b,15);
                    horh^[xcentr+a]:=ycentr-b;
               end;
               y:=y+1;
          end;
          x:=x+stepx;
     end;
if osi then
begin
     line(xcentr,0,xcentr,getmaxy-0);
     a:=Aconv(2000,0,phi,psi);
     b:=Bconv(2000,0,phi,psi);
     line(xcentr-a,ycentr+-b,xcentr+a,ycentr+b);
     a:=Aconv(2000,0,phi,psi);
     b:=Bconv(-2000,0,phi,psi);
     line(xcentr-a,ycentr-b,xcentr+a,ycentr+b);
end;
end;


begin
phi:=pi/8;
psi:=pi/8;
xcentr:=320;
ycentr:=240;
Xl:=-170;
Xh:=170;
Yl:=-170;
Yh:=170;
osi:=true;
stepx:=5;
end.