{   㯯:-2-98} 
Program Simple3D;
{$M $8125,0,655350}

uses dos;

type
  Vertex = record
    x, y, z,                { न 設 }
    rx, ry, rz : integer;   { न  設 }
  end;
  Face = record
    a, b, c,                { 設 ࠭ }
    color : integer;        {  ࠭ }
  end;
  vid = array[0..319,0..199] of byte;  {  }

const
  WnXS = 100; WnXE = 220;   { ࠡ뢠  ࠭ }
  WnYS = 50; WnYE = 150;
  MaxV = 11; MaxF = 19;     { ᫮ 設  ࠭ }

var
  fx, fy, fz : real;               {   ꥪ }
  dx, dy, dz : integer;            {   ࠭⢥ }
  V : array[0..MaxV] of Vertex;    { ᨢ 設 }
  F : array[0..MaxF] of Face;      { ᨢ ࠭ }
  Key : array[0..127] of boolean;  { ᨢ   }
  KbdIntVec : Procedure;           { ࠭  INT15 }
  pset : ^vid;                     {  }
  ltx, lty, ltz : integer;         {  ଠ ᢥ饭 }

{ ⠭ ० 320x200x256 }
procedure SetMode(mode:byte); assembler;
  asm
    mov ah, 0
    mov al, mode
    int 10h
  end;

{  室  RGB   - c1  c2 }
procedure palets(c1,c2,r1,g1,b1,r2,g2,b2:byte);
  var
    i,r,g,b : byte;
  begin
    for i := c1 to c2 do
      begin
        {  }
        r := round(r1+(r2-r1)/(c2-c1)*(i-c1));
        g := round(g1+(g2-g1)/(c2-c1)*(i-c1));
        b := round(b1+(b2-b1)/(c2-c1)*(i-c1));
        { ⠭  }
        port[$3c8] := i;
        port[$3c9] := r;
        port[$3c9] := g;
        port[$3c9] := b;
      end;
  end;

{ 뢮   ࠭ }
procedure DrawScr;
  var
    x, y : word;
  begin
    for x := WnXS to WnXE do
    for y := WnYS to WnYE do mem[$A000:y*320+x] := pset^[x,y];
  end;

{ ⪠  }
procedure ClrPset(c:byte);
  var
    x, y : word;
  begin
    for x := WnXS to WnXE do
    for y := WnYS to WnYE do Pset^[x,y] := c;
  end;

{  ࠡ稪 INT15 }
{$F+}
Procedure Catch_Int_15(Flags,CS,IP,AX,BX,CX,DX,SI,DI,DS,ES,BP:Word); Interrupt;
  Begin
    { ।塞 - 4Fh  塞 ᨢ   }
    If Hi(AX) = $4f then key[port[$60] and 127] := (port[$60] and 128) <> 128;
    Inline($9C);
    { 뢠   INT9 }
    mem[$0040:$001A] := mem[$0040:$001C];
    { 뢠 ।騩 ࠡ稪 }
    KbdIntVec;
  End; {$F-}

{  Integer ६ }
procedure swapi(var a,b:integer);
  var
    tmp : integer;
  begin
    tmp := a; a := b; b := tmp;
  end;

{ ᮢ 㣮쭨   }
procedure Triang(ax,ay,bx,by,cx,cy,color:integer);
  var
    x, y, xs, xe : integer;
  begin
    { 㥬 設 }
    if (ay>by) then begin swapi(ax,bx); swapi(ay,by); end;
    if (by>cy) then begin swapi(bx,cx); swapi(by,cy); end;
    if (ay>by) then begin swapi(ax,bx); swapi(ay,by); end;
    { 㥬 筮 㣮쭨 }
    for y := ay to cy do
      begin
        xs := round(ax+(y-ay)*(cx-ax)/(cy-ay+ord(cy=ay)));
        if (y < by) then
          xe := round(ax+(y-ay)*(bx-ax)/(by-ay))
        else
          xe := round(bx+(y-by)*(cx-bx)/(cy-by+ord(cy=by)));
        if (xs > xe) then swapi(xs,xe);
        for x := xs to xe do pset^[x,y] := color;
      end
  end;

{  ꥪ  dfx,dfy,dfz 㣫 }
procedure rotate(dfx,dfy,dfz:real);
  var
    i, u : integer;
  begin
    { 뢠 㣫  }
    fx := fx+dfx; fy := fy+dfy; fz := fz+dfz;
    { ॡࠥ 設 }
    for i := 0 to MaxV do
      begin
        {  X }
        V[i].ry := round(V[i].z*sin(fx)+V[i].y*cos(fx));
        V[i].rz := round(V[i].z*cos(fx)-V[i].y*sin(fx));
        {  Y }
        V[i].rx := round(V[i].rz*sin(fy)+V[i].x*cos(fy));
        V[i].rz := round(V[i].rz*cos(fy)-V[i].x*sin(fy));
        {  Z }
        u := V[i].ry;
        V[i].ry := round(V[i].rx*sin(fz)+u*cos(fz));
        V[i].rx := round(V[i].rx*cos(fz)-u*sin(fz));
        { 饭  ࠭⢥ }
        V[i].rx := V[i].rx + dx;
        V[i].ry := V[i].ry + dy;
        V[i].rz := V[i].rz + dz;
      end;
  end;

{ ᮢ 3D 業 }
procedure Draw3D;
  var
    i, u, ColorPlus : integer;
    zbuf : array[0..MaxF] of integer;
    ax, ay, bx, by, cx, cy, dx, dy : integer;
    nx,ny,nz,l:real;
 begin
    { ᨬ  ६  । 㤠 ࠭ }
    for i := 0 to MaxF do zbuf[i] := V[F[i].a].rz+V[F[i].b].rz+V[F[i].c].rz;
    { 㥬 ࠭  㤠 }
    repeat
      u := 0;
      for i := 0 to MaxF-1 do
        if zbuf[i+1] > zbuf[i] then
          begin
            swapi(F[i].a,F[i+1].a);
            swapi(F[i].b,F[i+1].b);
            swapi(F[i].c,F[i+1].c);
            swapi(F[i].color,F[i+1].color);
            swapi(zbuf[i],zbuf[i+1]);
            u := 1;
          end;
    until u = 0;
    { ॡࠥ ࠭ 稭  쭥 }
    for i := 0 to MaxF do
      begin
        { 뢠  ଠ  ࠭ }
        ax := V[F[i].c].rx-V[F[i].a].rx;
        ay := V[F[i].c].ry-V[F[i].a].ry;
        bx := V[F[i].c].rz-V[F[i].a].rz;
        by := V[F[i].b].rx-V[F[i].a].rx;
        cx := V[F[i].b].ry-V[F[i].a].ry;
        cy := V[F[i].b].rz-V[F[i].a].rz;
        nx := ay*cy-bx*cx;
        ny := bx*by-ax*cy;
        nz := ax*cx-ay*by;
        { ᫨ ࠭ 殬  , ... }
        if nz > 0 then
          begin
            { ନ㥬  ଠ }
            l := sqrt(nx*nx+ny*ny+nz*nz);
            nx := nx/l; ny := ny/l; nz := nz/l;
            { 뢠  梥 (ᨭ  ଠﬨ) }
            u := round(59*((nx*ltx)/1000+(ny*lty)/1000+(nz*ltz)/1000));
            if (u < -60) or (u > 0) then u := 0;
            ColorPlus := F[i].color+20-u;
            { ஥㥬 न 設  ᪮ ࠭ }
            ax := round(160+(V[F[i].a].rx)*(180/(V[F[i].a].rz+180)));
            ay := round(100-(V[F[i].a].ry)*(180/(V[F[i].a].rz+180)));
            bx := round(160+(V[F[i].b].rx)*(180/(V[F[i].b].rz+180)));
            by := round(100-(V[F[i].b].ry)*(180/(V[F[i].b].rz+180)));
            cx := round(160+(V[F[i].c].rx)*(180/(V[F[i].c].rz+180)));
            cy := round(100-(V[F[i].c].ry)*(180/(V[F[i].c].rz+180)));
            { 㥬 ࠭ }
            Triang(ax,ay,bx,by,cx,cy,ColorPlus);
          end;
      end;
  end;

{ 樠  }
procedure Init;
  var
    i:integer;
  begin
    { 墠뢠 뢠 INT15 }
    GetIntVec($15,@KbdIntVec);
    SetIntVec($15,Addr(Catch_Int_15));
    { 뤥塞    }
    New(pset);

    { 樠㥬 ᨢ 設 }
    V[0].x := 0;   V[0].y := -45; V[0].z := 0;
    V[1].x := 33;  V[1].y := -23; V[1].z := 23;
    V[2].x := 0;   V[2].y := 0;   V[2].z := 46;
    V[3].x := -32; V[3].y := -23; V[3].z := 23;
    V[4].x := -32; V[4].y := -23; V[4].z := -22;
    V[5].x := 0;   V[5].y := 0;   V[5].z := -45;
    V[6].x := 32;   V[6].y := -23;  V[6].z := -22;
    V[7].x := 32;   V[7].y := 23;   V[7].z := 23;
    V[8].x := 32;   V[8].y := 23;   V[8].z := -22;
    V[9].x := -32;  V[9].y := 23;   V[9].z := -22;
    V[10].x := 0;   V[10].y := 45;  V[10].z := 0;
    V[11].x := -32; V[11].y := 23;  V[11].z := 23;

    { 樠㥬 ᨢ ࠭ }
    F[0].a := 0;   F[0].b := 6;   F[0].c := 1;   F[0].color := 160;
    F[1].a := 1;   F[1].b := 7;   F[1].c := 2;   F[1].color := 160;
    F[2].a := 2;   F[2].b := 11;  F[2].c := 3;   F[2].color := 160;
    F[3].a := 3;   F[3].b := 4;   F[3].c := 0;   F[3].color := 160;
    F[4].a := 4;   F[4].b := 9;   F[4].c := 5;   F[4].color := 160;
    F[5].a := 5;   F[5].b := 8;   F[5].c := 6;   F[5].color := 160;
    F[6].a := 8;   F[6].b := 10;  F[6].c := 7;   F[6].color := 160;
    F[7].a := 9;   F[7].b := 11;  F[7].c := 10;  F[7].color := 160;
    F[8].a := 1;   F[8].b := 2;   F[8].c := 3;   F[8].color := 80;
    F[9].a := 1;   F[9].b := 3;   F[9].c := 0;   F[9].color := 80;
    F[10].a := 4;  F[10].b := 5;  F[10].c := 6;  F[10].color := 0;
    F[11].a := 4;  F[11].b := 6;  F[11].c := 0;  F[11].color := 0;
    F[12].a := 6;  F[12].b := 8;  F[12].c := 7;  F[12].color := 80;
    F[13].a := 6;  F[13].b := 7;  F[13].c := 1;  F[13].color := 80;
    F[14].a := 5;  F[14].b := 9;  F[14].c := 10; F[14].color := 0;
    F[15].a := 5;  F[15].b := 10; F[15].c := 8;  F[15].color := 0;
    F[16].a := 10; F[16].b := 11; F[16].c := 2;  F[16].color := 0;
    F[17].a := 10; F[17].b := 2;  F[17].c := 7;  F[17].color := 0;
    F[18].a := 9;  F[18].b := 4;  F[18].c := 3;  F[18].color := 80;
    F[19].a := 9;  F[19].b := 3;  F[19].c := 11; F[19].color := 80;

    { 뢮  ᪠  ࠭ }
    writeln('ࠢ ꥪ⮬ ⢫ :');
    writeln(' -                  :    X');
    writeln(' - ࠢ                :    Y');
    writeln(' -                   :    Z');
    writeln(' - A                     : 㤠 ꥪ');
    writeln(' - Z                     : ਡ ꥪ');
    writeln(' - DEL, END, HOME, PgDN  :  㣫  ᢥ');
    writeln;
    writeln('ন   ६.');
    writeln('Press ENTER to continue...');
    repeat until key[28];

    { ⠭ ᪨ ० }
    SetMode($13);
    {   }
    palets(80,140,0,0,0,63,0,0);         { R }
    palets(141,159,63,0,0,63,42,42);
    palets(0,60,0,0,0,0,63,0);           { G }
    palets(61,79,0,63,0,42,63,42);
    palets(160,220,0,0,0,0,0,63);        { B }
    palets(221,239,0,0,63,42,42,63);
  end;

{ 樠 }
procedure DeInit;
  begin
    Dispose(pset);
    SetMode(3);
    SetIntVec($15,@KbdIntVec);
  end;

var
  lx, ly : integer;
  l : real;
begin
  Init;
  lx := -30; ly := -30;
  repeat
    {   ଠ ᢥ饭 (᫨ ) }
    if key[83] and (lx > -60) then dec(lx);
    if key[81] and (lx < 60) then inc(lx);
    if key[71] and (ly > -50) then dec(ly);
    if key[79] and (ly < 50) then inc(ly);
    {   ଠ ᢥ饭 }
    l := sqrt(abs(lx*lx+ly*ly+2500));
    ltx := round((lx/l)*1000);
    lty := round((-ly/l)*1000);
    ltz := round((-50/l)*1000);
    { ਡ/㤠 ꥪ }
    if key[30] and (dz<300) then inc(dz);
    if key[44] and (dz>-50) then dec(dz);
    {  ꥪ (᫨ ) }
    rotate(0.01*ord(key[75]),0.01*ord(key[77]),0.01*ord(key[80]));
    { 頥  }
    ClrPset(185);
    { 뢮 3D 業   }
    Draw3D;
    pset^[lx+160,ly+101] := 50;
    pset^[lx+161,ly+100] := 130;
    pset^[lx+160,ly+99] := 50;
    pset^[lx+159,ly+100] := 130;
    { 뢮   ࠭ }
    DrawScr;
  until Key[1];
  DeInit;
end.