(* * * * * * * * * * * * * * * * * * * * * * * *
 *            3D   DOS v1.2             *
 *           ⬮:           *
 *       3D ꥪ, 3D ८ࠧ,        *
 *     ⥪஢  ᢥ饭.    *
 * * * * * * * * * * * * * * * * * * * * * * * *
 *           (c) 㫥订 .. 2000             *
 *             URL: pro3d.boom.ru              *
 *          e-mail: nord_ak@mail.ru            *
 * * * * * * * * * * * * * * * * * * * * * * * *)

{$M 8192,0,655360}
{$F-} {$O-} {$A+} {$G+} {$R-} {$S-} {$Q-}
{$V-} {$B-} {$X+} {$T-} {$P-} {$D-} {$E-} {$N+}

{ 砥 室 ⥪ }
uses Dos, Crt,  { ⠭ ⥪ BP }
     MyGraph,   {   ० 320x200x256 }
     MyMouse,   {    }
     MyBMP;     {   ᪨ 䠩 BMP }

type
  {  設 }
  TVertex = record
    x,y,z : integer;
    u,v : byte;
  end;
  {  ࠭ }
  TFace = record
    a,b,c : integer;
  end;

var
  Timer : longint absolute $0000:$046C; { ⥬ ⠩ }

  BMP : string;
  fade : boolean;     { ⥭ }
  sx, sy : word;      {  }
  rx, ry : word;      {  饭 }
  amp : byte;         { 㤠 }
  spd : byte;         {   }
  frx, fry : byte;    {   }
  ss : boolean;       {  ࠭⥫ ࠭ }
  mpresent : boolean; { ⠭  }

  fx, fy : integer;            {   ꥪ }
  sn : array[0..628] of real;  {  ᨭᮢ }
  cs : array[0..628] of real;  {  ᨭᮢ }
  R : array[0..76] of TVertex; {  設 }
  V : array[0..76] of TVertex; { ਣ 設 }
  F : array[0..119] of TFace;  { ࠭ }

{ 樠  ⭠ }
procedure InitData;
  var
    x, y, u : byte;
    i : word;
  begin
    for y := 0 to 6 do
    for x := 0 to 10 do
      begin
        i := y*11+x;
        V[i].x := x*10-50;
        V[i].y := y*10-30;
        V[i].z := 10;
        V[i].u := round((x*10-ord(x=10))*BMPmx/99);
        V[i].v := round((y*10-ord(y=6))*BMPmy/59);
        R[i].x := V[i].x;
        R[i].y := V[i].y;
        R[i].z := V[i].z;
        R[i].u := V[i].u;
        R[i].v := V[i].v;
      end;
    for y := 0 to 5 do
    for x := 0 to 9 do
      begin
        i := (y*10+x)*2;
        u := y*11+x;
        F[i].a := u;
        F[i].b := u+1;
        F[i].c := u+11;
        F[i+1].a := u+1;
        F[i+1].b := u+12;
        F[i+1].c := u+11;
      end;
    {  ⠡ ਣ᪨ 㭪権 }
    for i := 0 to 628 do sn[i] := sin(i/100);
    for i := 0 to 628 do cs[i] := cos(i/100);
  end;

{  ६ integer }
procedure swapi(var a,b:integer);
  var
    tmp : integer;
  begin
    tmp := a; a := b; b := tmp;
  end;

{  設  dfx,dfy ࠤ }
procedure rotate(dfx,dfy:integer);
  var
    i : word;
    lx, ly, lz : integer;
  begin
    fx := (fx+dfx) mod 628;
    fy := (fy+dfy) mod 628;
    for i := 0 to 76 do
      begin
        lx := V[i].x; ly := V[i].y; lz := V[i].z;
        {RotX}
        R[i].y := round(lz*sn[fx]+ly*cs[fx]);
        R[i].z := round(lz*cs[fx]-ly*sn[fx]);
        {RotY}
        R[i].x := round(R[i].z*sn[fy]+lx*cs[fy]);
        R[i].z := round(R[i].z*cs[fy]-lx*sn[fy]);
      end;
  end;

{ ਭ 3D 業   ⥪  ⥭   }
procedure Draw3D;
  {     ( ) }
  procedure Sort;
    var
      GC : array[0..2048] of integer;
      gap, i : word;
      eo : boolean;
    begin
      for i := 0 to 119 do GC[i] := ((R[F[i].a].z+R[F[i].b].z+R[F[i].c].z) div 3);
      gap := 119;
      repeat
        gap := gap div 2;
        repeat
          eo := false;
          i := 0;
          while i < 119-gap+1 do
            begin
              if GC[i] < GC[i+gap] then
                begin
                  swapi(GC[i],GC[i+gap]);
                  swapi(F[i].a,F[i+gap].a);
                  swapi(F[i].b,F[i+gap].b);
                  swapi(F[i].c,F[i+gap].c);
                  eo := true;
                end;
              inc(i);
            end;
        until not eo;
      until (gap = 1);
    end;
  var
    ax,ay,bx,by,cx,cy : integer;
    x,y,xs,ys,xe,ye   : integer;
    au,bu,cu,av,bv,cv : integer;
    us,ue,vs,ve,g     : integer;
    i : byte;
    l,du,dv,u,vn:real;
    nx,ny,nz:real;
    x1,y1,z1,x2,y2,z2 : integer;
  begin
    { 㥬 ࠭  㤠 }
    Sort;
    for i := 0 to 119 do
      begin
        if fade then
          begin
            { ⠥ ଠ  ࠭  㣮  ⪫  
              ஦.  ᭮ ⮣ 塞  "g" }
            x1 := R[F[i].c].x-R[F[i].a].x;
            y1 := R[F[i].c].y-R[F[i].a].y;
            z1 := R[F[i].c].z-R[F[i].a].z;
            x2 := R[F[i].b].x-R[F[i].a].x;
            y2 := R[F[i].b].y-R[F[i].a].y;
            z2 := R[F[i].b].z-R[F[i].a].z;
            nx := y1*z2-z1*y2;
            ny := z1*x2-x1*z2;
            nz := x1*y2-y1*x2;
            l := sqrt(nx*nx+ny*ny+nz*nz);
            g := abs(round(5*nz/l))-5;
          end;

        { 㥬 3D न  ࠭ }
        Ax := round(160+(R[F[i].a].x)*(180/(R[F[i].a].z+180)));
        Ay := round(100-(R[F[i].a].y)*(180/(R[F[i].a].z+180)));
        Au := R[F[i].a].u;
        Av := R[F[i].a].v;
        Bx := round(160+(R[F[i].b].x)*(180/(R[F[i].b].z+180)));
        By := round(100-(R[F[i].b].y)*(180/(R[F[i].b].z+180)));
        Bu := R[F[i].b].u;
        Bv := R[F[i].b].v;
        Cx := round(160+(R[F[i].c].x)*(180/(R[F[i].c].z+180)));
        Cy := round(100-(R[F[i].c].y)*(180/(R[F[i].c].z+180)));
        Cu := R[F[i].c].u;
        Cv := R[F[i].c].v;

        { 㥬 設 A -> B -> C }
        if (Ay>By) then begin swapi(Ax,Bx); swapi(Ay,By); swapi(Au,Bu); swapi(Av,Bv) end;
        if (By>Cy) then begin swapi(Bx,Cx); swapi(By,Cy); swapi(Bu,Cu); swapi(Bv,Cv) end;
        if (Ay>By) then begin swapi(Ax,Bx); swapi(Ay,By); swapi(Au,Bu); swapi(Av,Bv) end;

        { ⠥ 蠣 ⥪ }
        l := (by-ay)/(cy-ay+ord(cy=ay));
        xs := round(ax+(cx-ax)*l);
        us := round(au+(cu-au)*l);
        vs := round(av+(cv-av)*l);
        xe := bx; ue := bu; ve := bv;
        du := (us-ue)/(xs-xe+ord(xs=xe));
        dv := (vs-ve)/(xs-xe+ord(xs=xe));

        { 㥬 ⥪஢ 㣮쭨 }
        for y := ay to cy do
          begin
            l := (y-ay)/(cy-ay+ord(cy=ay));
            xs := round(ax+(cx-ax)*l);
            us := round(au+(cu-au)*l);
            vs := round(av+(cv-av)*l);

            if (y >= by) then
              begin
                l := (y-by)/(cy-by+ord(cy=by));
                xe := round(bx+(cx-bx)*l);
                ue := round(bu+(cu-bu)*l);
                ve := round(bv+(cv-bv)*l);
              end
            else
              begin
                l := (y-ay)/(by-ay+ord(by=ay));
                xe := round(ax+(bx-ax)*l);
                ue := round(au+(bu-au)*l);
                ve := round(av+(bv-av)*l);
              end;

            if xs > xe then begin swapi(xs,xe); swapi(us,ue); swapi(vs,ve); end;

            u := us; vn := vs;
            if fade then
              for x := xs to xe do
                begin
                  pset^[x,y] := gamma(pic[round(vn)*(BMPmx+1)+round(u)],g);
                  u := u+du; vn := vn+dv;
                end
            else
              for x := xs to xe do
                begin
                  pset^[x,y] := pic[round(vn)*(BMPmx+1)+round(u)];
                  u := u+du; vn := vn+dv;
                end
          end;
     end;
  end;

{ ॢ string  word }
function valc(s:string):word;
  var
    w : word;
    i : byte;
  begin
    w := 0;
    for i := 1 to length(s) do
      if (ord(s[i]) > 47) and (ord(s[i]) < 58) then w := w*10+ord(s[i])-48;
    valc := w;
  end;

function UpCaseC(s:string):string;
  var
    i : byte;
    s1 : string;
  begin
    s1 := '';
    for i := 1 to length(s) do s1 := s1 + UpCase(s[i]);
    UpCaseC := s1;
  end;

function trim(s:string):string;
  var
    s1 : string;
    i : byte;
  begin
    s1 := '';
    for i := 1 to length(s) do if s[i] <> ' ' then s1 := s1 + s[i];
    trim := s1;
  end;

procedure CopyRight;
  begin
    writeln('****************************************');
    writeln('              3D FLAG v1.2');
    writeln('****************************************');
    writeln('(c) 㫥订 .., 2000 (nord_ak@mail.ru)');
    writeln;
    writeln('URL: pro3d.boom.ru');
    writeln('     pro3d.chat.ru');
    writeln('     pro3d.da.ru');
    writeln;
    writeln('  ...');
    repeat until KeyPressed; ReadKey;
  end;

procedure help;
  begin
    writeln('  䠩 FLAG.INI   -  易⥫ ࠬ.');
    writeln;
    writeln(' 易⥫ ࠬ:');
    writeln('   BMP = <_⨭.bmp>     - ⨭ BMP 256 梥⮢,  RLE ');
    writeln('                                  Xres * Yres   <= 40000');
    writeln(' ⠫ 易⥫:');
    writeln('   FADE = <0|1>     (default=1) - ᯮ짮 ⥭');
    writeln('   SS = <0|1>       (default=0) - ० ࠭⥫ ࠭');
    writeln('   SX = <0..628>    (default=0) -   X  ࠤ*100 (. =314)');
    writeln('   SY = <0..628>    (default=0) -   Y  ࠤ*100');
    writeln('   RX = <0..30>     (default=0) - ᪮ 饭  X  ࠤ*100/frame');
    writeln('   RY = <0..30>     (default=0) - ᪮ 饭  Y  ࠤ*100/frame');
    writeln('   AMP = <0..50>   (default=15) - 㤠  3D ⭠');
    writeln('   SPD = <0..100>  (default=40) - ᪮ ');
    writeln('   FRX = <0..200> (default=100) -    X');
    writeln('   FRY = <0..200>  (default=50) -    Y');
    writeln;
    writeln('  ...');
    repeat until KeyPressed; ReadKey;
    writeln;
    writeln('  㪠  ࠬ    ப.');
    writeln(' FLAG.INI 㤥 ஢.');
    writeln;
    writeln(':');
    writeln('  FLAG.EXE <⨭.bmp> [/ࠬ]');
    writeln;
    writeln('ࠬ:');
    writeln('  /fade=<0|1>   (1)   - ᯮ짮 ⥭');
    writeln('  /ss=<0|1>     (0)   - ० ࠭⥫ ࠭');
    writeln('  /sx=<0..628>  (0)   - 砫 㣮  X  ࠤ*100 (..  = 314)');
    writeln('  /sy=<0..628>  (0)   - 砫 㣮  Y');
    writeln('  /rx=<0..30>   (0)   - ᪮ 饭  X  ࠤ*100/frame');
    writeln('  /ry=<0..30>   (0)   - ᪮ 饭  Y  ࠤ*100/frame');
    writeln('  /amp=<0..50>  (15)  - 㤠  3D ⭠');
    writeln('  /spd=<0..100> (50)  - ᪮ ');
    writeln('  /frx=<0..200> (100) -    X');
    writeln('  /fry=<0..200> (50)  -    Y');
    writeln;
    writeln('  ...');
    repeat until KeyPressed; ReadKey;
  end;

procedure LoadIni;
  const
    UnBMP = '?UNKNOWN?';
  var
    f : text;
    s : string;
    d : DirStr;
    n : NameStr;
    e : ExtStr;
  begin
    BMP := UnBMP;
    fsplit(ParamStr(0),d,n,e);
    if d[length(d)] <> '\' then d := d + '\';
    { ⠥ 䠩 }
    assign(f,d+'FLAG.INI');
    {$I-} reset(f); {$I+}
    if IOResult = 0 then
      begin
        while not eof(f) do
          begin
            readln(f,s); if pos(';',s) <> 0 then s := copy(s,1,pos(';',s)-1);
            s := UpCaseC(s);
            if pos('BMP',s) <> 0 then BMP := trim(copy(s,pos('=',s)+1,length(s))) else
            if pos('SS',s) <> 0 then ss := (valc(copy(s,pos('=',s)+1,length(s)))=1) else
            if pos('FADE',s) <> 0 then Fade := (valc(copy(s,pos('=',s)+1,length(s)))=1) else
            if pos('SX',s) <> 0 then sx := valc(copy(s,pos('=',s)+1,length(s))) else
            if pos('SY',s) <> 0 then sy := valc(copy(s,pos('=',s)+1,length(s))) else
            if pos('FRX',s) <> 0 then frx := valc(copy(s,pos('=',s)+1,length(s))) else
            if pos('FRY',s) <> 0 then fry := valc(copy(s,pos('=',s)+1,length(s))) else
            if pos('RX',s) <> 0 then rx := valc(copy(s,pos('=',s)+1,length(s))) else
            if pos('RY',s) <> 0 then ry := valc(copy(s,pos('=',s)+1,length(s))) else
            if pos('AMP',s) <> 0 then amp := valc(copy(s,pos('=',s)+1,length(s))) else
            if pos('SPD',s) <> 0 then spd := valc(copy(s,pos('=',s)+1,length(s)));
          end;
        close(f);
        if BMP = UnBMP then halt;
        fsplit(BMP,d,n,e);
        if d[length(d)] <> '\' then d := d + '\';
        if d = '\' then
          begin
            fsplit(ParamStr(0),d,n,e);
            if d[length(d)] <> '\' then d := d + '\';
            BMP := d+BMP;
          end;
      end
    else
      begin
        CopyRight;
        writeln('*************************************************************************');
        writeln('                     "FLAG.INI"');
        writeln('*************************************************************************');
        help; halt;
      end;
  end;

var
  x, y, mx, my : word;
  s : string;
  t : longint;
  enda : boolean;
BEGIN
  mpresent := MLoaded;
  { ⠭ DEFAULT ࠬ஢ }
  fade := true;
  ss := false;
  sx := 0; sy := 0;
  rx := 0; ry := 0;
  amp := 15;
  spd := 50;
  frx := 100; fry := 50;
  { ஢ਬ  ப }
  if ParamCount <> 0 then
    begin
      BMP := ParamStr(1);
      for x := 1 to ParamCount do
        begin
          s := UpCaseC(ParamStr(x));
          if pos('/FADE',s) <> 0 then fade := (valc(copy(s,pos('/FADE',s)+6,3))=1);
          if pos('/SS',s) <> 0 then ss := (valc(copy(s,pos('/SS',s)+4,3))=1);
          if pos('/SX',s) <> 0 then sx := valc(copy(s,pos('/SX',s)+4,4));
          if pos('/SY',s) <> 0 then sy := valc(copy(s,pos('/SY',s)+4,4));
          if pos('/RX',s) <> 0 then rx := valc(copy(s,pos('/RX',s)+4,4));
          if pos('/RY',s) <> 0 then ry := valc(copy(s,pos('/RY',s)+4,4));
          if pos('/AMP',s) <> 0 then amp := valc(copy(s,pos('/AMP',s)+5,4));
          if pos('/SPD',s) <> 0 then spd := valc(copy(s,pos('/SPD',s)+5,4));
          if pos('/FRX',s) <> 0 then frx := valc(copy(s,pos('/FRX',s)+5,4));
          if pos('/FRY',s) <> 0 then fry := valc(copy(s,pos('/FRY',s)+5,4));
          if pos('?',s) <> 0 then
            begin
              CopyRight;
              writeln('*************************************************************************');
              writeln('                                  ');
              writeln('*************************************************************************');
              help; halt;
            end;
        end;
    end
  else
    LoadIni; { 뢠 FLAG.INI  ⠥ ࠬ }
  { ⠭ ० 320x200x256 }
  SetMode($13);
  { 㦠 ⥪ }
  LoadBMP(BMP);
  { 樠㥬 3D ⭮ }
  InitData;
  { ⠭   業 }
  MSetWindow(0,0,319,199);
  MSetPos(160,100);
  SetDrawWindow(80,50,240,150);
  enda := false;
  repeat
    t := timer;
    { ⪠ ࠭ }
    ClrPset(0);
    { 塞 "" }
    for x := 0 to 10 do
    for y := 0 to 6 do
      V[y*11+x].z := round(amp*sn[(t*spd+x*frx+y*fry) mod 628]);
    { 稢, ᫨  }
    fx := sx+rx*t mod 628;
    fy := sy+ry*t mod 628;
    rotate(0,0);
    { 㥬 業   }
    Draw3D;
    { 뢮   ࠭ }
    DrawScr;
    { ஢塞  }
    MGetPos(mx,my);
    if mpresent and ss and ((mx<150) or (mx>170) or (my<90) or (my>110)) then enda := true;
    { ஢塞  }
    if keypressed and (((readkey = #27) and not ss) or ss) then enda := true;
  until enda;
  {  ⥪⮢ ० }
  SetMode(3);
END.
