unit modul;
interface
uses graph;
procedure init;
procedure rastr(i,j:integer;col:word);
procedure newrastr(i,j:integer; col:word);
procedure dekart;
procedure pixel(i,j:integer;col:word);
procedure simetr(i,j:integer;col:word);
procedure polyr(r,fi:integer;col:word);
procedure lines(xi,yi,xj,yj:integer; col:word);
procedure  simline(x1,y1,x2,y2:integer; col:word);
implementation
procedure init;
var
grdriver:integer;
grmode:integer;
grpath:string;
errcode:integer;
begin
grdriver:= vga;
grmode:=VGAhi;
grpath:='d:\BP\bgi';
initgraph(grdriver,grmode,grpath);
errcode:=graphresult;
if errcode<>grok then
halt(1);
end;
procedure rastr(i,j:integer;col:word);
var
z,z1,x,x1,y,y1:integer;
begin
z:=(getmaxx+1) div 32;
z1:=(getmaxy+1) div 32;
setfillstyle(1,col);
x:=(i-1)*z;
x1:=i*z;
y:=(j-1)*z1;
y1:=j*z1;
bar(x,y,x1,y1);
end;
procedure newrastr(i,j:integer; col:word);
var
i1,j1:integer;
begin
i1:=i+16;
if j<0 then
j1:=17-j
else
j1:=17-j;
rastr(i1,j1,col);
end;
procedure dekart;
var
k,m:integer;
begin
m:=0;
for k:=-15 to 16 do
begin
newrastr(k,m,15)
end;
k:=0;
for m:=-15 to 16 do
begin
newrastr(k,m,15)
end;
end;
procedure pixel(i,j:integer;col:word);
begin
dekart;
newrastr(i,j,col);
end;
procedure simetr(i,j:integer;col:word);
begin
if (j/i) <= (sqrt(2)/2) then
begin
dekart;
newrastr(i,j,col);
newrastr(i,-j,col);
newrastr(j,-i,col);
newrastr(-j,-i,col);
newrastr(-i,-j,col);
newrastr(-i,j,col);
newrastr(-j,i,col);
newrastr(j,i,col);
end
else
outtext('error');
end;
procedure polyr(r,fi:integer;col:word);
var
i,j:integer;
begin
i:=round(r*cos(fi));
j:=round(r*sin(fi));
pixel(i,j,col);
end;
procedure lines(xi,yi,xj,yj:integer; col:word);
var
d:array[1..500] of real;
x1,x2,y1,y2:integer;
x,dx,dy,i,j,z:integer;
m,y:real;
f:text;
begin
x1:=xi+320;
x2:=xj+320;
y1:=-yi+240;
y2:=-yj+240;
if x1<> x2 then
  begin
    dy:=y2-y1;
    dx:=x2-x1;
    m:=dy/dx;
    y:=y1;
    i:=1;
    if x1 < x2 then
      begin
        for x:=x1 to x2 do
        begin
          d[i]:=-y+240;
          inc(i);
          putpixel(x,round(y),col);
          y:=y+m;
        end;
      end
    else
     begin
       y:=y2;
       for x:=x2 to x1 do
         begin
           d[i]:=-y+240;
           inc(i);
           putpixel(x,round(y),col);
           y:=y+m;
         end;
     end;
     end
  else
   if y1=y2 then
     putpixel(x1,y1,col)
   else
    outtext('error');
 assign(f,'D:\bp\bin\result.txt');
{$i-}
rewrite(f);
{$i+}
writeLn(f,'(',xi,',',yi,',',xj,',',yj,')');
writeln(f,'蠣 :');
writeln(f,'蠣    (x,y)         Pixel  ');
for i:=1 to abs(x1-x2)+1 do
begin
if x1 > x2 then
begin
z:=x2;
inc(x2)
end
else
begin
z:=x1;
inc(x1);
end;
writeln(f,'',i,'  (',z-320,',',d[i]:3:3,')  (',z-320,' , ',ROUND(d[i]),')');
end;
close(f);
end;
procedure  simline(x1,y1,x2,y2:integer; col:word);
var
d:array[1..500] of real;
x,dx,dy,i,j,z,a:integer;
m,y:real;
f:text;
begin
z:=round((x2-x1)/2);
if x1<> x2 then
begin
dy:=y2-y1;
dx:=x2-x1;
m:=dy/dx;
y:=y1;
i:=1;
x:=x1;
for j:=1 to z+1 do
begin
d[i]:=y;
inc(i);
putpixel(x,round(y),col);
y:=y+m;
inc(x);
end;
a:=i;
y:=y2;
x:=x2;
for j:=1 to z+1 do
begin
d[i]:=y;
inc(i);
putpixel(x,round(y),col);
y:=y-m;
dec(x);
end;
end
else
if y1=y2 then
putpixel(x1,y1,col)
else
outtext('error');
assign(f,'D:\bp\bin\result.txt');
{$i-}
rewrite(f);
{$i+}
writeLn(f,'(',x1,',',y1,',',x2,',',y2,')');
writeln(f,'蠣 :');
writeln(f,'蠣    (x,y)       Pixel  ','    ','蠣    (x,y)         Pixel  ');
for i:=1 to  z+1 do
begin
writeln(f,'',i, '(',x1,',',d[i]:3:3,')  (',x1,',',ROUND(d[i]),')',' |  ',i,'(',x2,',',d[a]:3:3,')  (',x2,',',ROUND(d[a]),')');
inc(x1);
dec(x2);
inc(a);
end;
close(f);
end;
end.