program main_program;

uses crt, myobj, general, mygraph;

const
       MenuItems : array [0..4] of string =
         ('1.  ⥫',
          '2.  אַ',
          '3. ந 祭',
          '4.   . ०',
          '5. 室');

var

     dAngle : TCoordinates;
     Body : TCube;
     MyLine : TMyLine;
     i : integer;
     grDriver, grMode : integer;
     key : char;
     BCreated, LCreated : boolean;


function BringIn(Prompt : string) : longint;
var
    value : longint;
    BroughtIn : boolean;
begin
  repeat
   {$I-}
   write(Prompt,' ');
   readln(value);
   if IOResult <> 0 then
     begin
      BroughtIn := false;
      writeln('饭 訡  !  .');
     end
    else
     BroughtIn := true;
   {$I+}
  until BroughtIn;
  BringIn := value;
end;



function CreateBody : boolean;
var
    Left, Right : TCoordinates;
begin
   ClrScr;
   TextColor(15);
   writeln('1.  ⥫');
   TextColor(7);
   Left.X := BringIn('  न  窨:');
   Left.Y := BringIn(' Y न  窨:');
   Left.Z := BringIn(' Z न  窨:');
   Right.X := BringIn('  न ࠢ 窨:');
   Right.Y := BringIn(' Y न ࠢ 窨:');
   Right.Z := BringIn(' Z न ࠢ 窨:');

   Body.Init(Left, Right);
end;

function CreateLine : boolean;
var
    First, Second, LAngle : TCoordinates;
begin
  ClrScr;
  TextColor(15);
  writeln('2.  אַ');
  TextColor(7);
  First.X := BringIn('  न ࢮ 窨:');
  First.Y := BringIn(' Y न ࢮ 窨:');
  First.Z := BringIn(' Z न ࢮ 窨:');
  Second.X := BringIn('  न ன 窨:');
  Second.Y := BringIn(' Y न ன 窨:');
  Second.Z := BringIn(' Z न ன 窨:');
  LAngle.X := 0;
  LAngle.Y := 0;
  LAngle.Z := 0;
  MyLine.Init(First,Second);
end;

function GraphMode(BCreated, LCreated : boolean) : boolean;
var
    gdDriver, GrMode : integer;
    dAngle : TCoordinates;
begin

 dAngle.X := 0;
 dAngle.Y := 0;
 dAngle.Z := 0;


 if MyInitGraph then
  begin
    ShowPrompts(30,30,'ESC - 室',15);
    if BCreated then
      begin
       ShowPrompts(30,60,'a - ७ 祭',8);
       ShowPrompts(30,90,'s - 譥 祭',8);
      end;
    ShowPrompts(30,120,'d - ',4);
    repeat
     if BCreated then
      begin
       Body.ShiftToCenter;
       Body.Draw(4);
      end;
     if LCreated then
      begin
       MyLine.ShiftToCenter;
       MyLine.Draw(4);
      end;
     delay(100);
     if BCreated then
       begin
        Body.Hide;
        Body.Rotate(dAngle);
       end;
     if LCreated then
       begin
        MyLine.Hide;
        MyLine.Rotate(dAngle, Body.Center);
       end;
    if keypressed then
      begin
       key := readkey;
       if LCreated and MyLine.Cutted then
        begin
         if (key = 'a') or (key = 'A') then
           MyLine.Internal := true;
         if (key = 's') or (key = 'S') then
           MyLine.Internal := false;
        end;
       case key of
        'g' : dAngle.X := dAngle.X + 1;
        'b' : dAngle.X := dAngle.X - 1;
        'h' : dAngle.Y := dAngle.Y + 1;
        'n' : dAngle.Y := dAngle.Y - 1;
        'j' : dAngle.Z := dAngle.Z + 1;
        'm' : dAngle.Z := dAngle.Z - 1;
        'd' : if LCreated and bCreated then
              begin
               Body.Reset;
               MyLine.Reset;
               dAngle.X := 0;
               dAngle.Y := 0;
               dAngle.Z := 0;
              end;
       end;
      end;
    until key=#27;
    MyClose;
    Body.Reset;
    MyLine.Reset;
  end
 else
end;

Begin

  ClrScr;
 { for i := 0 to 7 do
   begin
    writeln(i,' normal  X: ',Body.Normals[i].Original.X,'  Y: ',Body.Normals[i].Original.Y,
                '  Z: ',Body.Normals[i].Original.Z);
   end;}
  {MyLine.CutOff(Body);
  MyLine.Internal := false;
  }
  BCreated := false;
  LCreated := false;
  repeat
    ClrScr;
    TextColor(15);
    for i := 0 to 4 do
     writeln(MenuItems[i]);
    writeln;
    TextColor(7);
    write(' 롮: ');
    readln(key);
    case key of
      '1' : BCreated := CreateBody;
      '2' : LCreated := CreateLine;
      '3' : if LCreated and BCreated then
             begin
              MyLine.CutOff(Body);
             end
            else
             begin
              writeln('  ᮧ  ⥫,  ');
              readkey;
             end;
      '4' : if LCreated or BCreated then
             begin
              if not GraphMode(BCreated, LCreated ) then
               begin
                writeln('᪨ ० ');
                readkey;
               end;
             end
            else
             begin
              writeln('  ᮧ  ⥫,  ');
              readkey;
             end;
      '5' : begin
              ClrScr;
              writeln('ணࠬ ᠭ 㤥⮬ 㯯 -1-99 ᠥ ᥥ');
              writeln(' ᢨ :)');
            end;
    else
     begin
      writeln;
      writeln(' 롮   ');
      readkey
     end;
    end;
  until key = '5';

End.