Program _3D;
 Uses CRT,Graph;
 Type
  Point = record
   X,Y,Z,RX,RY,RZ,AX,AY,AZ : Real;
          end;
  Mas = array [1..8] of Point;
 Var
  D,R1 : Integer;
  Kub : Mas;
  R : Real;
{---------------------------------------------------------}
 Procedure FeelScreen;
  Var
   i,j,k : Integer;
  Begin
   Randomize;
   For k:=1 to 3000 do
    Begin
     i:=Random(Random(Random(600)));
     j:=Random(Random(Random(400)));
     PutPixel(i,j,1);
     PutPixel(640-i,j,2);
     PutPixel(i,480-j,3);
     PutPixel(640-i,480-j,5);
    End;
  End;
{---------------------------------------------------------}
 Function Arccos(x : Real) : Real;
  Begin
   If x<>0 then
    Arccos := Arctan(sqrt(1/x*x-1))
           else
    Arccos := 3.145926/2;
  End;
{---------------------------------------------------------}
 Function Arcsin(x : Real) : Real;
  Begin
   If x<>1 then
    Arcsin := Arctan(sqrt(x*x/(1-x*x)))
           else
    Arcsin := 3.1415926/2;
  End;
{---------------------------------------------------------}
 Function Arctang(X,Y : Real) : Real;
  Begin
   If y<>0 then
    Begin
     If (X>=0) and (Y>=0) then
      Arctang := Arctan(x/y);
     If (X>=0) and (Y<0) then
      Arctang := Arctan(x/y)+3.1415926;
     If (X<0) and (Y>=0) then
      Arctang := Arctan(x/y)+3.1415926*2;
     If (X<0) and (Y<0) then
      Arctang := Arctan(x/y)+3.1415926;
    End
   else
    If (x>=0) then
     Arctang := 3.1415926/2
    else
     Arctang := 3.1415926*3/2;
  End;
{---------------------------------------------------------}
 Function P(x : Real) : Real;
  Begin
   P := x*3.145926/180;
  End;
{---------------------------------------------------------}
 Function PP(x : Real) : Real;
  Begin
   PP := X*180/3.1415926;
  End;
{---------------------------------------------------------}
 Procedure Restore(code : Integer);
  Var
   i : Integer;
  Begin
   For i := 1 to 8 do
    Case code of
     1 : Begin    {⮢ ⥬}
          Kub[i].Rx := sqrt(R*R-Kub[i].x*Kub[i].x);
          Kub[i].Ax := pp(arctang(Kub[i].z,Kub[i].y));
          Kub[i].Ry := sqrt(R*R-Kub[i].y*Kub[i].y);
          Kub[i].Ay := pp(arctang(Kub[i].x,Kub[i].z));
          Kub[i].Rz := sqrt(R*R-Kub[i].z*Kub[i].z);
          Kub[i].Az := pp(arctang(Kub[i].y,Kub[i].x));
         End;
     2 : Begin    {᪠ ⥬ ⭮⥫쭮 }
          Kub[i].y:=Kub[i].Rx*cos(p(Kub[i].Ax));
          Kub[i].z:=Kub[i].Rx*sin(p(Kub[i].Ax));
          Kub[i].Ry := sqrt(R*R-Kub[i].y*Kub[i].y);
          Kub[i].Ay := pp(arctang(Kub[i].x,Kub[i].z));
          Kub[i].Rz := sqrt(R*R-Kub[i].z*Kub[i].z);
          Kub[i].Az := pp(arctang(Kub[i].y,Kub[i].x));
         End;
     3 : Begin    {᪠ ⥬ ⭮⥫쭮 Y}
          Kub[i].x:=Kub[i].Ry*sin(p(Kub[i].Ay));
          Kub[i].z:=Kub[i].Ry*cos(p(Kub[i].Ay));
          Kub[i].Rx := sqrt(R*R-Kub[i].x*Kub[i].x);
          Kub[i].Ax := pp(arctang(Kub[i].z,Kub[i].y));
          Kub[i].Rz := sqrt(R*R-Kub[i].z*Kub[i].z);
          Kub[i].Az := pp(arctang(Kub[i].y,Kub[i].x));
         End;
     4 : Begin    {᪠ ⥬ ⭮⥫쭮 Z}
          Kub[i].x:=Kub[i].Rz*cos(p(Kub[i].Az));
          Kub[i].y:=Kub[i].Rz*sin(p(Kub[i].Az));
          Kub[i].Rx := sqrt(R*R-Kub[i].x*Kub[i].x);
          Kub[i].Ax := pp(arctang(Kub[i].z,Kub[i].y));
          Kub[i].Ry := sqrt(R*R-Kub[i].y*Kub[i].y);
          Kub[i].Ay := pp(arctang(Kub[i].x,Kub[i].z));
         End;
    End;
  End;
{---------------------------------------------------------}
 Procedure StartPosition;
  Begin
   Kub[1].x := -100;  Kub[1].y := 100;  Kub[1].z := -100;
   Kub[2].x := 100;   Kub[2].y := 100;  Kub[2].z := -100;
   Kub[3].x := 100;   Kub[3].y := 100;  Kub[3].z := 100;
   Kub[4].x := -100;  Kub[4].y := 100;  Kub[4].z := 100;
   Kub[5].x := -100;  Kub[5].y := -100; Kub[5].z := -100;
   Kub[6].x := 100;   Kub[6].y := -100; Kub[6].z := -100;
   Kub[7].x := 100;   Kub[7].y := -100; Kub[7].z := 100;
   Kub[8].x := -100;  Kub[8].y := -100; Kub[8].z := 100;
   Restore(1);
  End;
{---------------------------------------------------------}
 Function K(zz : Point) : Real;
  Begin
   k := 1 - 0.0015*zz.z
  End;
{---------------------------------------------------------}
 Function XX(zz : Point) : Integer;
  Begin
   XX := 320+round(K(zz)*zz.x);
  End;
{---------------------------------------------------------}
 Function YY(zz : Point) : Integer;
  Begin
   YY := 240-round(K(zz)*zz.y);
  End;
{---------------------------------------------------------}
 Procedure Show(Color : Byte);
  Begin
   SetColor(Color);
   Line(XX(Kub[1]),YY(Kub[1]),XX(Kub[2]),YY(Kub[2]));
   Line(XX(Kub[1]),YY(Kub[1]),XX(Kub[4]),YY(Kub[4]));
   Line(XX(Kub[1]),YY(Kub[1]),XX(Kub[5]),YY(Kub[5]));
   Line(XX(Kub[2]),YY(Kub[2]),XX(Kub[3]),YY(Kub[3]));
   Line(XX(Kub[2]),YY(Kub[2]),XX(Kub[6]),YY(Kub[6]));
   Line(XX(Kub[3]),YY(Kub[3]),XX(Kub[4]),YY(Kub[4]));
   Line(XX(Kub[3]),YY(Kub[3]),XX(Kub[7]),YY(Kub[7]));
   Line(XX(Kub[4]),YY(Kub[4]),XX(Kub[8]),YY(Kub[8]));
   Line(XX(Kub[5]),YY(Kub[5]),XX(Kub[6]),YY(Kub[6]));
   Line(XX(Kub[5]),YY(Kub[5]),XX(Kub[8]),YY(Kub[8]));
   Line(XX(Kub[6]),YY(Kub[6]),XX(Kub[7]),YY(Kub[7]));
   Line(XX(Kub[7]),YY(Kub[7]),XX(Kub[8]),YY(Kub[8]));
  End;
{---------------------------------------------------------}
 Procedure Spin;
  Var
   c : Char;
   i : Integer;
   v : Real;
  Begin
   Repeat
    c:=ReadKey;
    Case ord(c) of
     77 :  Begin
            For i:=1 to 8 do
              Kub[i].Ay := Kub[i].Ay - 1;
              Show(0);
              Restore(3);
              Show(4);
           End;
     75 :  Begin
            For i:=1 to 8 do
              Kub[i].Ay := Kub[i].Ay + 1;
              Show(0);
              Restore(3);
              Show(4)
           End;
     72 :  Begin
            For i:=1 to 8 do
              Kub[i].Ax := Kub[i].Ax + 1;
              Show(0);
              Restore(2);
              Show(4);
           End;
     80 :  Begin
            For i:=1 to 8 do
              Kub[i].Ax := Kub[i].Ax - 1;
              Show(0);
              Restore(2);
              Show(4);
           End;
     44 :  Begin
            For i:=1 to 8 do
              Kub[i].Az := Kub[i].Az + 1;
              Show(0);
              Restore(4);
              Show(4);
           End;
     46 :  Begin
            For i:=1 to 8 do
              Kub[i].Az := Kub[i].Az - 1;
              Show(0);
              Restore(4);
              Show(4);
           End;
    End;
   Until ord(c)=13;
  End;
{---------------------------------------------------------}
BEGIN
 R := 100*sqrt(3);
 ClrScr;
 D:=VGA;
 R1:=VgaHi;
 InitGraph(D,R1,'f:\bp71\Bgi');
 FeelScreen;
 StartPosition;
 Show(4);
 Spin;
 CloseGraph;
END.
